_layer_dialogs = {}


def add_layer_dialog(type, layer_class, function):
    try:
        _layer_dialogs[type].append((layer_class, function))
    except KeyError:
        _layer_dialogs[type] = [(layer_class, function)]
    

def init_layer_dialogs(type):
    try:
        del _layer_dialogs[type][:]
    except KeyError:
        pass


def open_properties_dialog(parent, layer, group):
    for cls, func in _layer_dialogs['properties']:
        if isinstance(layer, cls):
            func(parent, layer, group)
            return
    raise NotImplementedError
            
